# -*- coding:Latin-1 -*-

import es
import gamethread
from es import server_var
import os
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Complete C4Timer"
info.version = "1.1"
info.author = "Nicolous"
info.url = "http://mattie.info/forums/"
info.description = "Provide a C4 countdown"
info.tags = "c4;countdown"

CONFIGURATION_FILE = "addons/eventscripts/complete_c4timer/configuration.txt"

playerlist = []
countDown = -1

# ConVar publique pour tracer le script sur les moniteurs de serveurs
c4timer_version = es.ServerVar("c4timer_version",info.version).makepublic()

c4timer_activation = es.ServerVar("c4timer_activation","0","C4Timer : 1 = activation, 0 = off")
c4timer_chat_countdown = es.ServerVar("c4timer_chat_countdown","0","C4Timer : 1 = chat countdown, 0 = off")
c4timer_hud_countdown = es.ServerVar("c4timer_hud_countdown","0","C4Timer : 1 = hud countdown, 0 = off")
c4timer_center_countdown = es.ServerVar("c4timer_center_countdown","0","C4Timer : 1 = center countdown, 0 = off")
c4timer_amx_countdown = es.ServerVar("c4timer_amx_countdown","0","C4Timer : 1 = amx countdown, 0 = off")
c4timer_sound_countdown = es.ServerVar("c4timer_sound_countdown","0","C4Timer : 1 = sound countdown, 0 = off")

def downloads():
    """Planifie de faon dynamique les son  faire tlcharger aux joueurs"""
    if int(c4timer_sound_countdown) and int(server_var['mp_c4timer']) >= 0:
        index = int(server_var['mp_c4timer'])
        # bien que la ConVar soit borne, un es_forcevalue peut forcer une valeur incohrente (par exemple)
        if index<0:
            index = 0
        # Pour chaque seconde du C4, nous regardons s'il existe un fichier correspondant
        # format : c4timer_<SECONDE>_sec.mp3
        while index >= 0:
            nom = os.getcwd() + "/cstrike/sound/c4timer/c4timer_%s_sec.mp3" % (str(index))
            if os.path.isfile(nom): # le fichier existe t-il ?
                nom = "sound/c4timer/c4timer_%s_sec.mp3" % (str(index))
                es.stringtable("downloadables",nom)
            index -= 1   

def es_map_start(event_var):
    # Excution de la configuration du script
    if os.path.isfile(os.getcwd() + "/cstrike/" + CONFIGURATION_FILE):
        es.mexec("../" + CONFIGURATION_FILE)
        es.dbgmsg(0,"Complete C4Timer loaded")
    else:
        es.dbgmsg(0,"Unable to find " + CONFIGURATION_FILE + " !")

    es.soon("es_xdoblock C4Timer/downloads")

def player_connect(event_var):
    # Listage des ID connects au serveur (pour leur afficher le dcompte)
    global playerlist
    playerlist.append(event_var['userid'])

def player_disconnect(event_var):
    # Dlistage des ID connects au serveur
    global playerlist
    try:
        playerlist.remove(event_var['userid'])
    # Si l'index n'est pas dans la liste
    except ValueError:
        pass

def displayCountDown(count):
        if int(c4timer_chat_countdown):
            es.msg("#green",str(count))
        if int(c4timer_hud_countdown):
            es.usermsg("create", "hudcount", "HintText")
            es.usermsg("write", "byte", "hudcount", "1")
            es.usermsg("write", "string", "hudcount", str(count))
            for userid in playerlist:
                es.usermsg("send", "hudcount", userid, "0")
            es.usermsg("delete", "hudcount")
        if int(c4timer_center_countdown):
            es.centermsg(str(count))
        if int(c4timer_amx_countdown):
            for userid in playerlist:
                es.menu("1",userid, str(count))
        if int(c4timer_sound_countdown):
            nom = os.getcwd() + "/cstrike/sound/c4timer/c4timer_%s_sec.mp3" % (str(count))
            if os.path.isfile(nom):
                cmd = "play c4timer/c4timer_%s_sec.mp3" % (str(count))
                es.cexec_all(cmd)

def down():
    """Affiche et dcrmente le compte  rebourd"""
    global countDown
    if int(c4timer_activation) and countDown > -1:
        displayCountDown(countDown)
        countDown -= 1
        gamethread.delayed(1, down, ())
               
def bomb_planted(event_var):
    if int(c4timer_activation):
        global countDown
        countDown = int(server_var['mp_c4timer'])
        down()

def bomb_defused(event_var):
    global countDown
    countDown = -1 # arrt du compte  rebourd

def bomb_exploded(event_var):
    # parce que round_end est excut lorsque la bombe explose :
    if int(c4timer_activation):
        displayCountDown(0)

def round_end(event_var):
    global countDown
    countDown = -1

def player_say(event_var):
    downloads()
